

#-------------------------------------------------------------------------------
# Name: Les ours et les phoques
#
# Author:     Projet Formation NSI : Benjamin RAYBAUD et Boissac Frédéric
#
# Created:     25/10/2019
# Copyright:   (c) boissac/Raybaud 2019
# Licence:     free (pour une utilisation non commerciale et éducative)
#-------------------------------------------------------------------------------


from math import sqrt







def CalculDistance(animal1,animal2):

    d=sqrt((animal1["X"]-animal2["X"])**2+(animal1["Y"]-animal2["Y"])**2)

    return d

def TrouveAnimalPlusProche(listeAnimaux,animalInconnu):

    indice=0
    mini=CalculDistance(listeAnimaux[0],animalInconnu)
    for i in range(1,len(listeAnimaux)) :
        distance=CalculDistance(listeAnimaux[i],animalInconnu)
        if distance<mini :
            mini=distance
            indice=i

    return indice


def Prediction(listeAnimaux,animalInconnu):

    k=3
    nours=0
    nphoque=0

    while k!=0 :
        indice=TrouveAnimalPlusProche(listeAnimaux,animalInconnu)

        if listeAnimaux[indice]["nom"]=="ours" :
            nours+=1
        else:
            nphoque+=1
        del(listeAnimaux[indice])
        k-=1

    if nours>nphoque :
          return "Ours"
    else :
         return "Phoque"

if __name__ == '__main__':
    import OursPhoque
